using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.IO;
using System.Windows.Forms;

using ImageCompare.Common;

namespace ImageAnalyze.Common
{
    public class Config
    {
        private static Config instance = new Config();

        Dictionary<string, string> dic = new Dictionary<string, string>();

        private Config()
        {
            try
            {
                this.dic = this.Load();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message + "\r\n\r\n" + e.StackTrace);
            }
        }

        public static string GetString(string key)
        {
            string value = "";

            try
            {
                value = Config.instance.dic[key] as string;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
            }

            return value;
        }

        public void SetValue(string key, string value)
        {
        }

        private Dictionary<string, string> Load()
        {
            Dictionary<string, string> dic = new Dictionary<string, string>();

            if (!File.Exists(Global.FileName.ConfigFileName))
            {
                try
                {
                    this.CreateConfigFile();
                }
                catch (Exception e)
                {
                    throw e;
                }
            }

            using (SQLite sqlite = new SQLite(Global.FileName.ConfigFileName))
            {
                try
                {
                    string sql = "   select key, value from config; ";
                    using (IDataReader reader = sqlite.ExecuteReader(sql))
                    {
                        while (reader.Read())
                        {
                            dic.Add(reader["key"].ToString(), reader["value"].ToString());
                        }
                    }
                }
                catch (Exception e)
                {
                    throw e;
                }
                finally
                {
                    sqlite.Close();
                }
            }

            return dic;
        }

        public bool CreateConfigFile()
        {
            bool result = false;

            using (SQLite sqlite = new SQLite(Global.FileName.ConfigFileName))
            {
                string sql =
                    "   CREATE TABLE config (key TEXT, value TEXT); " +
                    "   INSERT INTO config VALUES('DefaultRootTagName','ׂẴ^O'); " +
                    "   INSERT INTO config VALUES('RootTagName','ׂẴ^O'); " +
                    "   INSERT INTO config VALUES('DefaultNewTagName','V^O'); " +
                    "   INSERT INTO config VALUES('NewTagName','V^O'); " +
                    "   INSERT INTO config VALUES('DefaultDataFileName','data.db'); " +
                    "   INSERT INTO config VALUES('CurrentDataFileName','data.db'); "
                ;

                try
                {
                    sqlite.Execute(sql);
                    sqlite.Commit();
                    result = true;
                }
                catch (Exception e)
                {
                    sqlite.Rollback();
                    throw e;
                }
                finally
                {
                    sqlite.Close();
                }
            }

            return result;
        }

        public bool Save()
        {
            bool result = false;

            using (SQLite sqlite = new SQLite(Global.FileName.ConfigFileName))
            {
                try
                {
                    /*
                    string query = string.Format(
                        "   update config set " +
                        "       width = {0}, " +
                        "       height = {1}, " +
                        "       loginId = '{2}', " +
                        "       loginPassword = '{3}', " +
                        "       tradeNumber = '{4}', " +
                        "       doAutoLogin = '{5}', " +
                        "       minimumTradeAmount = {6}, " +
                        "       goldenCrossShortMaDayCount = {7}, " +
                        "       goldenCrossLongMaDayCount = {8}, " +
                        "       deadCrossShortMaDayCount = {9}, " +
                        "       deadCrossLongMaDayCount = {10}, " +
                        "       conversionMaDaycount = {11}, " +
                        "       plusConversionPercent = {12}, " +
                        "       minusConversionPercent = {13}, " +
                        "       brandCount = {14}, " +
                        "       realBudget = {15}, " +
                        "       marginBudget = {16}, " +
                        "       useMarginTrade = '{17}', " +
                        "       realGain = {18}, " +
                        "       realLossCut = {19}, " +
                        "       marginGain = {20}, " +
                        "       marginLossCut = {21}, " +
                        "       accountType = '{22}', " +
                        "       autoDataGet = '{23}', " +
                        "       autoDataGetTime = '{24}', " +
                        "       losscutTime = '{25}', " +
                        "       firstOrderTimeLimit = '{26}', " +
                        "       orderTimer = '{27}', " +
                        "       orderTime = '{28}', " +
                        "       doTradeAllExtractedBrand = '{29}', " +
                        "       kmtrend = '{30}', " +
						"       retry = '{31}' " +
                        "",
                        this.width.ToString(),
                        this.height.ToString(),
                        this.loginId,
                        this.loginPassword,
                        this.tradeNumber,
                        this.doAutoLogin.ToString(),
                        this.minimumTradeAmount.ToString(),
                        this.goldenCrossShortMaDayCount.ToString(),
                        this.goldenCrossLongMaDayCount.ToString(),
                        this.deadCrossShortMaDayCount.ToString(),
                        this.deadCrossLongMaDayCount.ToString(),
                        this.conversionMaDayCount.ToString(),
                        this.plusConversionPercent.ToString(),
                        this.minusConversionPercent.ToString(),
                        this.brandCount.ToString(),
                        this.realBudget.ToString(),
                        this.marginBudget.ToString(),
                        this.useMarginTrade.ToString(),
                        this.realGain.ToString(),
                        this.realLosscut.ToString(),
                        this.marginGain.ToString(),
                        this.marginLosscut.ToString(),
                        this.accountType.ToString(),
                        this.autoGetData.ToString(),
                        this.timeAutoDataGet.ToString(),
                        this.timeLosscut.ToString(),
                        this.timeFirstOrderTimeLimit.ToString(),
                        this.orderTimer.ToString(),
                        this.orderTime.ToString(),
                        this.doTradeAllExtractedBrand.ToString(),
                        this.kmTrend.ToString(),
						this.retry.ToString()
                    );


                    sqlite.Execute(query);
                     */

                    result = true;
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex.Message);
                }
                finally
                {
                    sqlite.Close();
                }
            }


            return result;
        }

        public static Config Instance
        {
            get { return Config.instance; }
        }
    }
}
