using System;
using System.Data;
using System.IO;
using Finisar.SQLite;

namespace ImageAnalyze.Common
{
	/// <summary>
	/// SQLite ւ̗eՂȃANZX񋟂NXłB
	/// </summary>
	public class SQLite : IDisposable
	{
		private bool isNew;
		private IDbConnection connection;
		private IDbCommand command;

		/// <summary>
		/// RXgN^łB
		/// </summary>
		/// <param name="fileName">ڑf[^x[XB</param>
		public SQLite(string fileName)
		{
			// w肳ꂽf[^x[Xɑ݂邩ׂB
			isNew = !File.Exists(fileName);

			// ڑɗp IDbConnection 擾B
			connection = new SQLiteConnection(String.Format(
				"Data Source={0}; Version=3; New={1};",
				fileName, isNew ? "True" : "False"
			));

			try {
				// f[^x[XɐڑB
				connection.Open();
			} catch(Exception ex) {
				throw ex;
			}

			// NGsɗp IDbCommand 擾B
			command = connection.CreateCommand();

			// gUNVJnB
			Begin();
		}

        /// <summary>
        /// w肵Õe[uf[^x[Xɑ݂邩ׂ܂B
        /// </summary>
        /// <param name="tableName">e[u</param>
        /// <returns></returns>
        public bool IsExistTable(string tableName)
        {
            bool result = false;

            try
            {
                string query = string.Format(
                    "   select count(*) from sqlite_master where type = 'table' and name = '{0}' ",
                    tableName
                );
                using (IDataReader reader = this.ExecuteReader(query))
                {
                    reader.Read();
                    result = (Convert.ToInt32(reader[0]) != 0);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
               // this.Close();
            }

            return result;
        }

		/// <summary>
		/// f[^x[Xؒf܂B
		/// </summary>
		public void Close()
		{
			// f[^x[XɐڑĂȂ΁A
            if (connection != null && connection.State != ConnectionState.Closed)
            {
				// gUNVIB
				End();

				// f[^x[XؒfB
				connection.Close();
				connection = null;
			}
		}

		/// <summary>
		/// NG𔭍s܂B
		/// </summary>
		/// <param name="commandText">sNGB</param>
		/// <returns>e󂯂sB</returns>
		public int Execute(string commandText)
		{
			int result;

			// NG IDbCommand ɐݒ肷B
			command.CommandText = commandText;

			try {
				// NG𔭍sB
				result = command.ExecuteNonQuery();
			} catch(Exception ex) {
				throw ex;
			}

			return result;
		}

		/// <summary>
		/// NG𔭍s܂B
		/// </summary>
		/// <param name="commandText">sNGB</param>
		/// <returns>ʂ擾邽߂ IDataReaderB</returns>
		public IDataReader ExecuteReader(string commandText)
		{
			IDataReader result;

			// NG IDbCommand ɐݒ肷B
			command.CommandText = commandText;

			try {
				// NG𔭍sB
				result = command.ExecuteReader();
			} catch(Exception ex) {
				throw ex;
			}

			return result;
		}
		
		/// <summary>
		/// gUNVJn܂B
		/// </summary>
		private void Begin()
		{
			// NG𔭍sB
			Execute("BEGIN");
		}

		/// <summary>
		/// gUNVI܂B
		/// </summary>
		private void End()
		{
			// NG𔭍sB
			Execute("END");
		}

		/// <summary>
		/// R~bg܂B
		/// </summary>
		public void Commit()
		{
			// NG𔭍sB
			Execute("COMMIT");
			// gUNVJnB
			Begin();
		}

		/// <summary>
		/// [obN܂B
		/// </summary>
		public void Rollback()
		{
			// NG𔭍sB
			Execute("ROLLBACK");
			// gUNVJnB
			Begin();
		}

		/// <summary>
		/// f[^x[XVKɍ쐬ꂽǂ\܂B
		/// </summary>
        public bool IsNew
        {
            get { return isNew; }
        }

		#region IDisposable o

		public void Dispose()
		{
			// f[^x[XؒfB
			Close();
		}

		#endregion

        public static DateTime ToDateTime(object result)
        {
            try
            {
                DateTime datetime = DateTime.MinValue;
                DateTime.TryParse(result.ToString().Replace('-', '/'), out datetime);
                return datetime;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
	}
}
