using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using ImageSimilarityCalculator;

namespace ImageCompare.Controls
{
    public partial class PageImageCompare : UserControl
    {
        private ColorMap cm1;
        private ColorMap cm2;

        public PageImageCompare()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                this.textImageUrl.Text = ofd.FileName;
                this.pictureBox.BackgroundImage = Image.FromFile(ofd.FileName);

                this.cm1 = ColorMap.Create(this.pictureBox.BackgroundImage);

                this.text.Text = string.Format("R:{0}%\r\nG:{1}%\r\nB:{2}%\r\nM{3}%\r\n",
                    this.cm1.r,
                    this.cm1.g,
                    this.cm1.b,
                    this.cm1.m
                );
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                this.textImageUrl2.Text = ofd.FileName;
                this.pictureBox2.BackgroundImage = Image.FromFile(ofd.FileName);

                this.cm2 = ColorMap.Create(this.pictureBox2.BackgroundImage);

                this.text2.Text = string.Format("R:{0}%\r\nG:{1}%\r\nB:{2}%\r\nM{3}%\r\n",
                    this.cm2.r,
                    this.cm2.g,
                    this.cm2.b,
                    this.cm2.m
                );

                ImageSimilarityInfo isi = new ImageSimilarityInfo(this.cm1, this.cm2);

                this.text3.Text = string.Format("All:{0}%\r\nR:{1}%\r\nG:{2}%\r\nB:{3}%\r\nM{4}%\r\n",
                    isi.similarity,
                    isi.r,
                    isi.g,
                    isi.b,
                    isi.m
                );
            }
        }
    }
}
